VERSION 5.00
Begin VB.Form frmZStackAcq 
   Caption         =   "Z Stack Acquisition"
   ClientHeight    =   3495
   ClientLeft      =   165
   ClientTop       =   750
   ClientWidth     =   4695
   Icon            =   "ZStackAcq.frx":0000
   LinkTopic       =   "Form1"
   ScaleHeight     =   3495
   ScaleWidth      =   4695
   StartUpPosition =   3  'Windows Default
   Begin VB.TextBox txtPeriod 
      Height          =   372
      Left            =   3720
      TabIndex        =   20
      Top             =   2160
      Width           =   852
   End
   Begin VB.TextBox txtSettle 
      Height          =   372
      Left            =   3720
      TabIndex        =   18
      Top             =   1680
      Width           =   852
   End
   Begin VB.CommandButton cmdCancelZ 
      Caption         =   "Cancel Z Stack"
      Height          =   372
      Left            =   2640
      TabIndex        =   17
      Top             =   2640
      Width           =   1932
   End
   Begin VB.TextBox txtDelay 
      Height          =   372
      Left            =   3720
      TabIndex        =   15
      Top             =   1200
      Width           =   852
   End
   Begin VB.CommandButton cmdLaunchCapture 
      Caption         =   "Launch Capture Program / Enable HW Trigger"
      Height          =   500
      Left            =   2640
      TabIndex        =   14
      Top             =   120
      Width           =   1932
   End
   Begin VB.CommandButton cmdCapture 
      Caption         =   "Capture One Frame"
      Height          =   372
      Left            =   2640
      TabIndex        =   13
      Top             =   720
      Width           =   1932
   End
   Begin VB.CommandButton cmdSetBot 
      Caption         =   "Set Bottom"
      Height          =   372
      Left            =   120
      TabIndex        =   12
      Top             =   1080
      Width           =   972
   End
   Begin VB.CommandButton cmdSetTop 
      Caption         =   "Set Top"
      Height          =   372
      Left            =   120
      TabIndex        =   11
      Top             =   600
      Width           =   972
   End
   Begin VB.TextBox txtStepSize 
      Height          =   372
      Left            =   1800
      TabIndex        =   8
      Top             =   2160
      Width           =   732
   End
   Begin VB.TextBox txtNumPlanes 
      Height          =   372
      Left            =   1800
      TabIndex        =   7
      Top             =   1680
      Width           =   732
   End
   Begin VB.CommandButton cmdSetStepSize 
      Caption         =   "Set Step Size (um)"
      Height          =   372
      Left            =   120
      TabIndex        =   6
      Top             =   2160
      Width           =   1572
   End
   Begin VB.CommandButton cmdSetNum 
      Caption         =   "Set Num. of Planes"
      Height          =   372
      Left            =   120
      TabIndex        =   5
      Top             =   1680
      Width           =   1572
   End
   Begin VB.CommandButton cmdZStack 
      Caption         =   "Acquire Z Stack"
      Height          =   372
      Left            =   120
      TabIndex        =   4
      Top             =   2640
      Width           =   2412
   End
   Begin VB.CommandButton cmdExecute 
      Caption         =   "Execute"
      Height          =   372
      Left            =   2640
      TabIndex        =   3
      Top             =   3840
      Width           =   1452
   End
   Begin VB.TextBox txtCommand 
      Height          =   372
      Left            =   120
      TabIndex        =   2
      Top             =   3840
      Width           =   2412
   End
   Begin VB.CommandButton cmdGetTopBot 
      Caption         =   "Get Joystick Top and Bottom"
      Height          =   372
      Left            =   120
      TabIndex        =   0
      Top             =   120
      Width           =   2412
   End
   Begin VB.Label lblDelay 
      Caption         =   "Capture Delay (sec.)"
      Height          =   375
      Left            =   2760
      TabIndex        =   16
      Top             =   1200
      Width           =   975
      WordWrap        =   -1  'True
   End
   Begin VB.Label Label1 
      Caption         =   "Period (sec.) 0 - not used"
      Height          =   375
      Left            =   2760
      TabIndex        =   21
      Top             =   2160
      Width           =   975
      WordWrap        =   -1  'True
   End
   Begin VB.Label lblSettle 
      Caption         =   "Settle Delay (sec.)"
      Height          =   375
      Left            =   2760
      TabIndex        =   19
      Top             =   1680
      Width           =   975
      WordWrap        =   -1  'True
   End
   Begin VB.Line Line1 
      X1              =   120
      X2              =   4560
      Y1              =   0
      Y2              =   0
   End
   Begin VB.Label lblBot 
      BorderStyle     =   1  'Fixed Single
      Height          =   372
      Left            =   1200
      TabIndex        =   10
      Top             =   1080
      Width           =   1332
   End
   Begin VB.Label lblTop 
      BorderStyle     =   1  'Fixed Single
      Height          =   372
      Left            =   1200
      TabIndex        =   9
      Top             =   600
      Width           =   1332
   End
   Begin VB.Label lblMsg 
      BorderStyle     =   1  'Fixed Single
      Height          =   255
      Left            =   120
      TabIndex        =   1
      Top             =   3120
      Width           =   4455
   End
   Begin VB.Menu mnuZServ 
      Caption         =   "Z-Server"
      Begin VB.Menu mnuShowZServ 
         Caption         =   "Show Z server"
      End
      Begin VB.Menu mnuHideZServ 
         Caption         =   "Hide Z server"
      End
      Begin VB.Menu mnuZLog 
         Caption         =   "Z-stack Log"
      End
   End
   Begin VB.Menu mnuCapture 
      Caption         =   "Image Capture"
      Begin VB.Menu mnuEOSUtil 
         Caption         =   "Canon EOS Utility"
      End
      Begin VB.Menu mnuCanonRemote 
         Caption         =   "Canon Remote Capture"
      End
      Begin VB.Menu mnuBreeze 
         Caption         =   "DSLR Remote Pro"
      End
      Begin VB.Menu mnuFujiSU 
         Caption         =   "Fuji StudioUtility"
      End
      Begin VB.Menu mnuPath 
         Caption         =   "From captureprogpath.txt"
      End
      Begin VB.Menu mnuHWT 
         Caption         =   "Hardware Trigger"
      End
      Begin VB.Menu mnuSep1 
         Caption         =   "-"
      End
      Begin VB.Menu mnuDelayKey 
         Caption         =   "Delay Focus-to-Key"
      End
      Begin VB.Menu mnuTriggerHold 
         Caption         =   "HW Trigger Hold Time"
      End
      Begin VB.Menu mnuSep2 
         Caption         =   "-"
      End
      Begin VB.Menu mnuAdvanced 
         Caption         =   "Advanced"
         Begin VB.Menu mnuFujiCapKey 
            Caption         =   "Fuji Capture Key"
         End
      End
   End
End
Attribute VB_Name = "frmZStackAcq"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Sub cmdCancelZ_Click()
   CancelFlag = 1
End Sub

Private Sub cmdCapture_Click()
   Call CaptureImage
End Sub

Private Sub cmdExecute_Click()
   lblMsg.Caption = FTool.Exec(txtCommand.Text)
End Sub

Private Sub cmdGetTopBot_Click()
   Dim rs As String, wrd As String, ret As Integer
   Dim numobj As Long, w1 As Double, w2 As Double
   rs = FTool.Exec("Obj GetNum"): lblMsg.Caption = rs: DoEvents
   On Error GoTo Err
   ret = Give1stWord(rs, wrd)
   numobj = CLng(wrd)
   lblMsg.Caption = Str$(numobj)
   'GET TWO LAST OBJECTS
   rs = FTool.Exec("Obj Get" & Str(numobj - 1)): lblMsg.Caption = rs: DoEvents
   ret = Give1stWord(rs, wrd): ret = Give1stWord(rs, wrd): ret = Give1stWord(rs, wrd)
   w1 = CDbl(wrd)
   lblMsg.Caption = Str$(w1)
   
   rs = FTool.Exec("Obj Get" & Str(numobj)): lblMsg.Caption = rs: DoEvents
   ret = Give1stWord(rs, wrd): ret = Give1stWord(rs, wrd): ret = Give1stWord(rs, wrd)
   w2 = CDbl(wrd)
   
   'ZTop & BOTTOM
   If (w1 > w2) Then
      ZTop = w2: ZBot = w1
   Else
      ZTop = w1: ZBot = w2
   End If
   Call DisplayValues
   Exit Sub
Err:
   lblMsg.Caption = sErr
End Sub

Private Sub cmdLaunchCapture_Click()
   Dim h As Long
   h = LaunchCapture()
   If (h > 0) Then
      cmdCapture.Enabled = True: cmdZStack.Enabled = True
   Else
      cmdCapture.Enabled = False: cmdZStack.Enabled = False
   End If
End Sub

Private Sub cmdSetBot_Click()
   Dim spos As String, wrd As String, ret As Integer
   spos = FTool.Exec("Z ?")
   ret = Give1stWord(spos, wrd): If (ret < 0) Then GoTo Err
   On Error GoTo Err
   ZBot = CDbl(wrd)
   Call DisplayValues
   Exit Sub
Err:
   lblMsg.Caption = sErr
End Sub

Private Sub cmdSetNum_Click()
   Dim ret As Integer
   On Error GoTo Err
   NumPlanes = CInt(txtNumPlanes.Text)
   ret = UpdateStepSize(): If (ret < 0) Then GoTo Err
   Call DisplayValues
   Exit Sub
Err:
   lblMsg.Caption = sErr
End Sub

Private Sub cmdSetStepSize_Click()
   Dim ret As Integer
   On Error GoTo Err
   StepSize = CDbl(txtStepSize.Text)
   ret = UpdateNumPlanes(): If (ret < 0) Then GoTo Err
   Call DisplayValues
   Exit Sub
Err:
   lblMsg.Caption = sErr
End Sub

Private Sub cmdSetTop_Click()
   Dim spos As String, wrd As String, ret As Integer
   spos = FTool.Exec("Z ?")
   ret = Give1stWord(spos, wrd): If (ret < 0) Then GoTo Err
   On Error GoTo Err
   ZTop = CDbl(wrd)
   Call DisplayValues
   Exit Sub
Err:
   lblMsg.Caption = sErr
End Sub

Private Sub cmdZStack_Click()
   Dim ret As Integer
   ret = AcquireZStack()
End Sub

Private Sub Form_Load()
   ZTop = UNDEF: ZBot = UNDEF: StepSize = UNDEF: NumPlanes = UNDEF
   CaptureDelay = 2: SettleDelay = 1: Period = 0
   KeyDelay = 200: TriggerHold = 500
   FujiKey = 1
   
'  CHOOSE THE SERVER - COMMENT OUT ONE OF THE NEXT TWO LINES:
'   Set FTool = CreateObject("ScopeTool.ScopeToolCmd")
   Set FTool = CreateObject("LiftTool.LiftToolCmd")

   FTool.Exec ("Show")
   FTool.Exec ("Joy On")
   FTool.Exec ("Hide")
   
   'ALTERNATIVE SYNTAX
   'LiftToolCmd (<COMMAND STRING>)
   'ScopeToolCmd (<COMMAND STRING>)
   
   'DISABLE CAPTURE BUTTONS BEFORE PROGRAM IS SELECTED
   cmdLaunchCapture.Enabled = False: cmdCapture.Enabled = False: cmdZStack.Enabled = False
   
   txtDelay.Text = Format(CaptureDelay, "0.0")
   txtSettle.Text = Format(SettleDelay, "0.0")
   txtPeriod.Text = Format(Period, "0.0")
End Sub


Private Sub Form_Unload(Cancel As Integer)
   FTool.Exec ("Unload")
End Sub

Private Sub mnuBreeze_Click()
   CaptureProg = 3
   Call CheckCaptureChoice
End Sub

Private Sub mnuCanonRemote_Click()
   CaptureProg = 2
   Call CheckCaptureChoice
End Sub

Private Sub mnuCapture_Click()
   Call CheckCaptureChoice
   If (CaptureProg = 1) Then mnuEOSUtil.Checked = True: Exit Sub
   If (CaptureProg = 2) Then mnuCanonRemote.Checked = True: Exit Sub
   If (CaptureProg = 3) Then mnuBreeze.Checked = True: Exit Sub
   If (CaptureProg = 4) Then mnuFujiSU.Checked = True: Exit Sub
   If (CaptureProg = 100) Then mnuHWT.Checked = True: Exit Sub
End Sub
Private Sub CheckCaptureChoice()
   If (CaptureProg = 1) Then
      mnuEOSUtil.Checked = True: mnuCanonRemote.Checked = False: mnuBreeze.Checked = False
      mnuFujiSU.Checked = False: mnuHWT.Checked = False: mnuPath.Checked = False
      cmdLaunchCapture.Enabled = True: Exit Sub
   End If
   If (CaptureProg = 2) Then
      mnuEOSUtil.Checked = False: mnuCanonRemote.Checked = True: mnuBreeze.Checked = False
      mnuFujiSU.Checked = False: mnuHWT.Checked = False: mnuPath.Checked = False
      cmdLaunchCapture.Enabled = True: Exit Sub
   End If
   If (CaptureProg = 3) Then
      mnuEOSUtil.Checked = False: mnuCanonRemote.Checked = False: mnuBreeze.Checked = True
      mnuFujiSU.Checked = False: mnuHWT.Checked = False: mnuPath.Checked = False
      cmdLaunchCapture.Enabled = True: Exit Sub
   End If
   If (CaptureProg = 4) Then
      mnuEOSUtil.Checked = False: mnuCanonRemote.Checked = False: mnuBreeze.Checked = False
      mnuFujiSU.Checked = True: mnuHWT.Checked = False: mnuPath.Checked = False
      cmdLaunchCapture.Enabled = True: Exit Sub
   End If
   If (CaptureProg = 5) Then
      mnuEOSUtil.Checked = False: mnuCanonRemote.Checked = False: mnuBreeze.Checked = False
      mnuFujiSU.Checked = False: mnuHWT.Checked = False: mnuPath.Checked = True
      cmdLaunchCapture.Enabled = True: Exit Sub
   End If
   If (CaptureProg = 100) Then
      mnuEOSUtil.Checked = False: mnuCanonRemote.Checked = False: mnuBreeze.Checked = False
      mnuFujiSU.Checked = False: mnuHWT.Checked = True: mnuPath.Checked = False
      cmdLaunchCapture.Enabled = True: Exit Sub
   End If
End Sub

Private Sub mnuDelayKey_Click()
   Dim s As String
   lblMsg.Caption = ""
   s = InputBox("Enter delay between changing focus on the window and sending capture key (in msec.)", "Capture Key Delay", Format(KeyDelay, "0"))
   On Error GoTo BadInput
   KeyDelay = CLng(s)
   Exit Sub
BadInput:
   lblMsg.Caption = "Not a number"
End Sub

Private Sub mnuEOSUtil_Click()
   CaptureProg = 1
   Call CheckCaptureChoice
End Sub

Private Sub mnuFujiCapKey_Click()
   Dim s As String
   lblMsg.Caption = ""
   s = InputBox("Enter Fuji Capture Key: 1 for Space, 2 for Enter", "Fuji Capture Key", Format(FujiKey, "0"))
   On Error GoTo BadInput
   FujiKey = CLng(s)
   Exit Sub
BadInput:
   lblMsg.Caption = "Not a number"
End Sub

Private Sub mnuFujiSU_Click()
   CaptureProg = 4
   Call CheckCaptureChoice
End Sub

Private Sub mnuHideZServ_Click()
   FTool.Exec ("Hide")
End Sub

Private Sub mnuHWT_Click()
   CaptureProg = 100
   Call CheckCaptureChoice
End Sub

Private Sub mnuPath_Click()
   CaptureProg = 5
   Call CheckCaptureChoice
   Call ReadCaptureprogpath
   Call ReadCapturekey
End Sub

Private Sub mnuShowZServ_Click()
   FTool.Exec ("Show")
End Sub

Private Sub mnuTriggerHold_Click()
   Dim s As String
   lblMsg.Caption = ""
   s = InputBox("Enter HW Trigger Hold Time (in msec.)", "Trigger Hold Time", Format(TriggerHold, "0"))
   On Error GoTo BadInput
   TriggerHold = CLng(s)
   Exit Sub
BadInput:
   lblMsg.Caption = "Not a number"
End Sub

Private Sub mnuZLog_Click()
   Dim s As String
   Dim ahndl
   If (Len(ZLog) = 0) Then Exit Sub
   Clipboard.Clear   ' Clear Clipboard.
   Clipboard.SetText ZLog  ' Put text on Clipboard.
   ahndl = Shell("notepad.exe", vbNormalFocus)
   AppActivate ahndl
   SendKeys "^V", True
End Sub
